include "VVram.inc"
include "Chars.inc"

ext VVram_
ext CellMap_


ColumnCount equ 12
FloorCount equ 4
ColumnsPerByte equ 2
FloorHeight equ 4
ColumnWidth equ 2

Cell_Space equ 0
Cell_LowerMask equ 3
Cell_CrackedFloor equ 1
Cell_HardFloor equ 3
Cell_LadderDown equ 2
Cell_UpperMask equ 0ch
Cell_BrokenFloor equ 4
Cell_LadderUp equ 8
Cell_Item equ 0ch


; ptr<byte> CellMapPtr(byte x, byte y);
cseg
CellMapPtr_: public CellMapPtr_
    push v | push b
        clc|rar
        mov c,a
        mov a,e
        add a,a ;*2
        add a,e ;*3
        add a,a ;*6
        add a,c
        
        adi a,low CellMap_ | mov l,a
        mvi a,0 | aci a,high CellMap_ | mov h,a
    pop b | pop v
ret


; void MapToVVram();
cseg
MapToVVram_Row:
    mov a,e | stax h | inx h
    mov a,d | stax h
    mov a,l | adi a,VVramWidth-1 | mov l,a
    mov a,h | aci a,0 | mov h,a
ret    
MapToVVram_Rows:
    do
        call MapToVVram_Row
        dcr b
    repeat
ret
MapToVVram_: public MapToVVram_
    push v | push h | push d | push b
        lxi h,VVram_
        lxi d,CellMap_
        mvi c,FloorCount-1
        do
            mvi b,ColumnCount/ColumnsPerByte-1
            do
                push b
                                    _deb: public _deb
                    ldax d | inx d
                    push d
                        mov c,a
                        mvi b,ColumnsPerByte-1
                        do
                            push b
                                mov a,c
                                ani a,Cell_UpperMask
                                if eqi a,Cell_BrokenFloor
                                    lxi d,Char_Space shl 8 or Char_Space
                                    mvi b,3-1
                                    call MapToVVram_Rows
                                    lxi d,(Char_CrackedFloor + 7) shl 8 or (Char_CrackedFloor + 6)
                                    call MapToVVram_Row
                                    jmp nextColumn
                                endif
                                if eqi a,Cell_Item
                                    lxi d,Char_Space shl 8 or Char_Space
                                    call MapToVVram_Row
                                    lxi d,(Char_Item + 1) shl 8 or (Char_Item + 0)
                                    call MapToVVram_Row
                                    lxi d,(Char_Item + 3) shl 8 or (Char_Item + 2)
                                    call MapToVVram_Row
                                    lxi d,Char_HardFloor shl 8 or Char_HardFloor
                                    call MapToVVram_Row
                                    jmp nextColumn
                                endif
                                if eqi a,Cell_LadderUp
                                    lxi d,Char_Ladder+1 shl 8 or Char_Ladder+0
                                    mvi b,3-1
                                    call MapToVVram_Rows
                                    mov a,c
                                    ani a,Cell_LowerMask
                                    if nei a,Cell_LadderDown
                                        lxi d,Char_HardFloor shl 8 or Char_HardFloor
                                    endif
                                    call MapToVVram_Row
                                    jmp nextColumn
                                endif
                                lxi d,Char_Space shl 8 or Char_Space
                                mvi b,2-1
                                call MapToVVram_Rows
                                
                                mov a,c
                                ani a,Cell_LowerMask
                                if eqi a,Cell_LadderDown
                                    lxi d,Char_Ladder+1 shl 8 or Char_Ladder+0
                                    mvi b,2-1
                                    call MapToVVram_Rows
                                    jmp nextColumn
                                endif
                                lxi d,Char_Space shl 8 or Char_Space
                                call MapToVVram_Row

                                mov a,c
                                ani a,Cell_LowerMask
                                if eqi a,Cell_CrackedFloor
                                    lxi d,(Char_CrackedFloor + 1) shl 8 or (Char_CrackedFloor + 0)
                                else
                                    if eqi a,Cell_HardFloor
                                        lxi d,Char_HardFloor shl 8 or Char_HardFloor
                                    endif
                                endif
                                call MapToVVram_Row

                                nextColumn:
                                mov a,l | adi a,low(-VVramWidth*FloorHeight+ColumnWidth) | mov l,a
                                mov a,h | aci a,high(-VVramWidth*FloorHeight+ColumnWidth) | mov h,a
                            pop b
                            mov a,c
                            rar | rar | rar | rar
                            ani a,$0f
                            mov c,a
                            dcr b
                        repeat
                    pop d
                pop b
                dcr b
            repeat
            mov a,l | adi a,low(VVramWidth*FloorHeight-ColumnCount*ColumnWidth) | mov l,a
            mov a,h | aci a,high(VVramWidth*FloorHeight-ColumnCount*ColumnWidth) | mov h,a
            dcr c
        repeat
    pop b | pop d | pop h | pop v
ret
