#include "Status.h"
#include "Vram.h"
#include "Main.h"
#include "Sprite.h"
#include "Print.h"
#include "Chars.h"
#include "VVram.h"

static ptr<byte> PrintS(ptr<byte> pVram, ptr<byte> p)
{
    byte c;
    while ((c = *p) != 0) {
        pVram = PrintC(pVram, c);
        ++p;
    }
    return pVram;
}

void PrintStatus() 
{
    // PrintS(Vram + 0 * VramStep, "SC");   
    // PrintS(Vram + 9 * VramStep, "ST");
    PrintByteNumber2(Vram + 7 * VramStep, CurrentStage + 1);
    // PrintC(Vram+ 14 * VramStep, 'T');
    {
        ptr<byte> pVram;
        pVram = Vram + 14 * VramStep;
        if (RemainCount > 1) {
            byte i;
            i = RemainCount - 1;
            do {
                byte c;
                c = Char_Man;
                repeat (2) {
                    pVram = PutU(pVram, c);
                    ++c;
                }
                pVram -= 2 * CharWidth;
                repeat (2) {
                    pVram = PutL(pVram, c);
                    ++c;
                }
                --i;
            } while (i > 0);
        }
    }
    PrintScore();
    PrintTime();
}

void PrintScore()
{
    ptr<byte> pVram;
    
    pVram = PrintNumber5(Vram + 0 * VramStep, Score);
    PrintC(pVram, '0');
}

void PrintTime()
{
    PrintByteNumber3(Vram + 10 * VramStep, StageTime);
    PresendVram();
}

void PrintGameOver()
{
    PrintS(Vram + VramRowSize * 4 + (VramRowSize - 9 * VramStep) / 2, "GAME OVER");
    PresendVram();
}

void PrintTimeUp() 
{
    PrintS(Vram + VramRowSize * 4 + (VramRowSize - 7 * VramStep) / 2, "TIME UP");
    PresendVram();
}

void Title()
{
    ClearScreen(); 
    HideAllSprites();
    PrintStatus(); 
    {
        static const byte[] TitleBytes = {
            //	C
            0x00, 0x0e, 0x05, 0x0b, 
            0x0c, 0x03, 0x00, 0x00, 
            0x04, 0x0b, 0x00, 0x0a, 
            0x00, 0x04, 0x05, 0x01, 
            //	R
            0x0c, 0x07, 0x05, 0x0b, 
            0x0c, 0x03, 0x08, 0x0f, 
            0x0c, 0x07, 0x0f, 0x02, 
            0x04, 0x01, 0x04, 0x05, 
            //	A
            0x00, 0x0e, 0x0d, 0x02, 
            0x0c, 0x03, 0x00, 0x0f, 
            0x0c, 0x07, 0x05, 0x0f, 
            0x04, 0x01, 0x00, 0x05, 
            //	C
            0x00, 0x0e, 0x05, 0x0b, 
            0x0c, 0x03, 0x00, 0x00, 
            0x04, 0x0b, 0x00, 0x0a, 
            0x00, 0x04, 0x05, 0x01, 
            //	K
            0x0c, 0x03, 0x08, 0x07, 
            0x0c, 0x0b, 0x07, 0x00, 
            0x0c, 0x03, 0x0d, 0x02, 
            0x04, 0x01, 0x00, 0x05, 
            //	Y
            0x0c, 0x03, 0x0c, 0x03, 
            0x04, 0x0b, 0x0e, 0x01, 
            0x00, 0x0c, 0x03, 0x00, 
            0x00, 0x04, 0x01, 0x00, 
        };
        constexpr byte LogoLength = 6;
        ptr<byte> p;
        ptr<byte> pVram;
        pVram = Vram + VramRowSize * 1 + (VVramWidth - LogoLength * 4) / 2 * CharWidth;
        p = TitleBytes;
        repeat (LogoLength) {
            repeat (2) {
                repeat (4) {
                    pVram = PutU(pVram, *p);
                    ++p;
                }
                pVram -= 4 * CharWidth;
                repeat (4) {
                    pVram = PutL(pVram, *p);
                    ++p;
                }
                pVram += VramRowSize - 4 * CharWidth;
            }
            pVram += 4 * CharWidth - VramRowSize * 2;
        }
        PrintS(Vram + VramRowSize * 3 + (VVramWidth / 2 + LogoLength * 2) * CharWidth - 4 * VramStep, "MINI");
    }

    PrintS(Vram + VramRowSize * 5 + 0 * VramStep, "PUSH TRIGGER BUTTON");
    PrintS(Vram + VramRowSize * 7 + 7 * VramStep, "INUFUTO 2023");

    PresendVram();
}